package rocks.zipcode.io.quiz4.fundamentals;

import java.util.TreeSet;

/**
 * @author leon on 18/12/2018.
 */
public class PalindromeEvaluator {
    public static String[] getAllPalindromes(String string) {
        TreeSet<String> treeSet = new TreeSet<>();
        for (int i = 0; i < string.length(); i++) {
            treeSet.add(String.valueOf(string.charAt(i)));
        }

        for (int i = 0; i < string.length() / 2; i++) {
            if(string.charAt(i) == string.charAt(string.length() - 1 - i)) {
                treeSet.add(string.substring(i, string.length() - i));
            }
        }
        return treeSet.toArray(new String[0]);
    }

    public static Boolean isPalindrome(String string) {
        for (int i = 0; i < string.length() - 1; i++) {
            if (string.charAt(i) != string.charAt(string.length() - 1 - i)) {
                return false;
            }
        }
        return true;
    }

    public static String reverseString(String string) {
        String[] reversedString = new String[string.length()];
        StringBuilder sb = new StringBuilder(string.length());
        for (int i = string.length() - 1, j = 0; i >= 0; i--, j++) {
            sb.append(string.charAt(i));
        }
        return sb.toString();
    }
}
